#ifndef THRILLE_UPC_H
#define THRILLE_UPC_H

#define SRC_ARGS    const char*, unsigned int, const char*
#define THRILLE_DECLS(PASS_NAME) \
extern void thrille_before_read_ ## PASS_NAME(int,uint64_t,SRC_ARGS,int,int);\
extern void thrille_after_read_ ## PASS_NAME(int,uint64_t,SRC_ARGS,int,int);\
extern void thrille_before_write_ ## PASS_NAME(int,uint64_t,SRC_ARGS,int,int);\
extern void thrille_after_write_ ## PASS_NAME(int,uint64_t,SRC_ARGS,int,int);\
extern void thrille_before_lock_ ## PASS_NAME(int, uint64_t, SRC_ARGS);\
extern void thrille_after_lock_ ## PASS_NAME(int, uint64_t, SRC_ARGS);\
extern void thrille_before_unlock_ ## PASS_NAME(int, uint64_t, SRC_ARGS);\
extern void thrille_after_unlock_ ## PASS_NAME(int, uint64_t, SRC_ARGS);\
extern void thrille_before_notify_ ## PASS_NAME(int, int, SRC_ARGS);\
extern void thrille_after_notify_ ## PASS_NAME(int, int, SRC_ARGS);\
extern void thrille_before_wait_ ## PASS_NAME(int, int, SRC_ARGS);\
extern void thrille_after_wait_ ## PASS_NAME(int, int, SRC_ARGS);\
extern void thrille_before_try_wait_ ## PASS_NAME(int, int, SRC_ARGS);\
extern void thrille_after_try_wait_ ## PASS_NAME(int, int, SRC_ARGS);\


#ifdef UPCR_THRILLE_RACER
    THRILLE_DECLS(racer)
#define THRILLE_BEFORE(function,_expr,pass,extra...)  thrille_before_ ## function ## _racer\
        (upcr_mythread(), _expr, __FILE__, __LINE__, #_expr , ## extra)
#define THRILLE_AFTER(function,_expr,pass,extra...)   thrille_after_ ## function ## _racer\
        (upcr_mythread(), _expr, __FILE__, __LINE__, #_expr , ## extra)
#define THRILLE_AFTER_RET(function,_expr,_retarg,pass,extra...)   ({typeof (_retarg) _ret = _retarg;\
        thrille_after_ ## function ## _racer(upcr_mythread(), _expr, __FILE__, __LINE__, #_expr , ## extra)\
        _ret;})
#elif defined(UPCR_THRILLE_TESTER)
    THRILLE_DECLS(tester)
#define THRILLE_BEFORE(function,_expr,pass,extra...)  thrille_before_ ## function ## _tester\
        (upcr_mythread(), _expr, __FILE__, __LINE__, #_expr , ## extra)
#define THRILLE_AFTER(function,_expr,pass,extra...)   thrille_after_ ## function ## _tester\
        (upcr_mythread(), _expr, __FILE__, __LINE__, #_expr , ## extra)
#define THRILLE_AFTER_RET(function,_expr,_retarg,pass,extra...)   ({typeof (_retarg) _ret = _retarg;\
        thrille_after_ ## function ## _tester(upcr_mythread(), _expr, __FILE__, __LINE__, #_expr , ## extra)\
        _ret;})
#else
    #define THRILLE_BEFORE(function,_expr,pass,extra...)
    #define THRILLE_AFTER(function,_expr,pass,extra...)
    #define THRILLE_AFTER_RET(function,_expr,_retarg,pass,extra...) (_retarg)
#endif


#if 0
#define THRILLE_BEFORE_READ(_addr)  thrille_before_read(MYTHREAD, (long)_addr, __FILE__, __LINE__, #_addr) 
#define THRILLE_BEFORE_WRITE(_addr) thrille_before_write(MYTHREAD, (long)_addr, __FILE__, __LINE__, #_addr) 
#endif


#endif

