/*
 * addr_skiplist.c
 *
 *  Created on: Sep 13, 2010
 *      Author: parkcs
 */

#include <stdlib.h>
#include <string.h>
#include "addr_skiplist.h"

#define BLOCK_SIZE 4*1024*1024
void* addr_skiplist_pool = NULL;
unsigned int addr_skiplist_pool_remaining = 0;

/* level must be in [0, MAX_SKIPLIST_LEVEL) */
void* addr_skiplist_allocator(unsigned int level)
{
	unsigned int size = sizeof(skiplist_node) + sizeof(void*) * level;
	//printf("Allocation %d bytes for level %d node\n", size, level);
	if(addr_skiplist_pool_remaining < size) {
		addr_skiplist_pool = malloc(BLOCK_SIZE);
		addr_skiplist_pool_remaining = BLOCK_SIZE;
	}
	void* ret = addr_skiplist_pool;
	addr_skiplist_pool += size;
	addr_skiplist_pool_remaining -= size;
	memset(ret, 0, size);
	return ret;
}

int addr_comparator(void* l, void* r)
{
	uintptr_t left = (uintptr_t)l;
	uintptr_t right = (uintptr_t)r;
	return (left < right) ? -1 : (left > right ? 1 : 0);
}

skiplist* new_addr_skiplist()
{
	skiplist* ret = malloc(sizeof(skiplist));
	ret->allocator = addr_skiplist_allocator;
	ret->comparator = addr_comparator;
	ret->prettyprinter = NULL;
	ret->level = 0;
	ret->head = ret->allocator(MAX_SKIPLIST_LEVEL-1);
	return ret;
}

