/*
 * skiplist.h
 *
 *  Created on: Sep 13, 2010
 *      Author: parkcs
 */

#ifndef SKIPLIST_H_
#define SKIPLIST_H_

//#define NODES_PER_CHUNK	128
#define LOG2RANDMAX		(31)	// adjust if RAND_MAX != 2^31
#define LEVEL_ADJUST	(32-LOG2RANDMAX)
// __builtin_clz counts # of leading 0's
#define geomrand()		(__builtin_clz(rand())-LEVEL_ADJUST)
#define MAX_SKIPLIST_LEVEL	(LOG2RANDMAX)

typedef struct _skiplist_node_t {
	void * key;
	void * data;
	// This array size is determined when node allocated
	struct _skiplist_node_t * forward[1];
} skiplist_node;

typedef struct _skiplist_t {
	int level;
	int (*comparator)(void *, void *);
	void* (*allocator)(unsigned int);
	void (*prettyprinter)(skiplist_node *, int level);
	skiplist_node * head;

} skiplist;

/* Returns data associated with key if exists */
void* skiplist_find(skiplist* sl, void* key);

/* Returns skiplist_node if already exists in list, or 0 on success */
skiplist_node* skiplist_insert(skiplist* sl, void* key, void* data);

void skiplist_print(skiplist* sl);

#endif /* SKIPLIST_H_ */
