/*
 * upct_list.h - a UPC implementation of a list for UPC Thrille
 *
 */

#ifndef UPCT_LIST_H
#define UPCT_LIST_H

#include "upct_types.h"

struct _list_elem {
    shared void * data;
    shared list_elem * next;
};

void list_init(shared list_elem *);
void list_add(shared list_elem *, shared void *);
int list_size(shared list_elem *);
void list_print(shared list_elem*, void (*print_func)(shared void *));
shared list_elem * list_get_next(shared list_elem *);
shared void * list_get_data(shared list_elem *);

int list_intersection(shared list_elem *, 
                      shared list_elem *,
                      int (*)(shared void *, shared void *)); 

int list_contains(shared list_elem *,
                  shared void *, 
                  int (*) (shared void *, shared void *));

#endif // UPCT_LIST_H
