/*
 * upct_multiset.h - a UPC implementation of a multiset for sets in UPC Thrille
 *
 */

#ifndef UPCT_MULTISET_H
#define UPCT_MULTISET_H

#include "upct_types.h"
#include "upct_list.h"

struct _multiset_elem;
struct _multiset_t;

typedef struct _multiset_elem multiset_elem;
typedef struct _multiset_t multiset_t;


struct _multiset_elem {
    shared list_elem * list;
    int valid;
    shared multiset_elem * left;
    shared multiset_elem * right;
};


struct _multiset_t {
    int (*comp_lt)(shared void *, shared void *);
    shared multiset_elem * root;
};



void multiset_init(shared multiset_t *, int (*)(shared void *, shared void *));
void multiset_add(shared multiset_t *, shared void *);
void multiset_remove(shared multiset_t *, shared void *);
int multiset_size(shared multiset_t *);
void multiset_print(shared multiset_t *, void (*) (shared void *));
shared list_elem * multiset_get(shared multiset_t *, shared void *);


#endif // UPCT_MULTISET_H
