/*
 * upct_set.h - a UPC implementation of a set for sets in UPC Thrille
 *
 */

#ifndef UPCT_SET_H
#define UPCT_SET_H

#include "upct_types.h"
#include "upct_list.h"

struct _set_elem;
struct _set_t;

typedef struct _set_elem set_elem;
typedef struct _set_t set_t;


struct _set_elem {
    shared void * data;
    int valid;
    shared set_elem * left;
    shared set_elem * right;
};


struct _set_t {
    int (*comp_lt)(shared void *, shared void *);
    shared set_elem * root;
};


void set_init(shared set_t *, int (*)(shared void *, shared void *));
void set_add(shared set_t *, shared void *);
shared void * set_get(shared set_t *, shared void *);
void set_remove(shared set_t *, shared void *);
int set_size(shared set_t *);
void set_print(shared set_t * ls, void (*print_func) (shared void *));



/* WARNING: only call the functions below on a set of lock_addr */
shared list_elem * lockset_getlist(shared set_t *);

#endif // UPCT_SET_H
