#define N   8  /* Dimension of vectors/matrices */

/* C = A \dot B */
void vecTvec(shared int A[], shared int B[], shared int* C) {
    *C = 0;
    for(int i = 0; i < N; i++)
        *C += A[i]*B[i];
}

void printvec(shared int A[]) {
    printf("( ");
    for(int i = 0; i < N; i++) {
        printf("%3d ", A[i]);
    }
    printf(")");
}

shared int *a, *b;
shared int c;

int main(int argc, char* argv[])
{
   a = (shared int *)upc_all_alloc(N, sizeof(int));
   b = (shared int *)upc_all_alloc(N, sizeof(int));

   srand(MYTHREAD);
   upc_forall(int i = 0; i < N; i++; &a[i]) {
       a[i] = rand() % 100;
       b[i] = rand() % 100;
   }

   upc_barrier;

   if (MYTHREAD == 0) {
       printvec(a);
       printf(" . ");
       printvec(b);
       printf("T");
       vecTvec(a, b, &c);
   }

   upc_barrier;

   if(MYTHREAD == 0) {
       printf("= %d\n", c);
       upc_free(a);
       upc_free(b);
   }

}
